-- This file is automatically generated using maintenance/generateSchemaSql.php.
-- Source: sql/tables.json
-- Do not modify this file directly.
-- See https://www.mediawiki.org/wiki/Manual:Schema_changes
CREATE TABLE /*_*/reading_list (
  rl_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
  rl_user_id INTEGER UNSIGNED NOT NULL,
  rl_is_default SMALLINT DEFAULT 0 NOT NULL,
  rl_name BLOB NOT NULL, rl_description BLOB DEFAULT '' NOT NULL,
  rl_date_created BLOB DEFAULT '19700101000000' NOT NULL,
  rl_date_updated BLOB DEFAULT '19700101000000' NOT NULL,
  rl_size INTEGER UNSIGNED DEFAULT 0 NOT NULL,
  rl_deleted SMALLINT DEFAULT 0 NOT NULL
);

CREATE INDEX rl_user_default ON /*_*/reading_list (rl_user_id, rl_is_default);

CREATE UNIQUE INDEX rl_user_deleted_name_id ON /*_*/reading_list (
  rl_user_id, rl_deleted, rl_name, rl_id
);

CREATE UNIQUE INDEX rl_user_deleted_updated_id ON /*_*/reading_list (
  rl_user_id, rl_deleted, rl_date_updated,
  rl_id
);

CREATE UNIQUE INDEX rl_user_name_id ON /*_*/reading_list (rl_user_id, rl_name, rl_id);

CREATE UNIQUE INDEX rl_user_updated_id ON /*_*/reading_list (
  rl_user_id, rl_deleted, rl_date_updated,
  rl_id
);

CREATE INDEX rl_deleted_updated ON /*_*/reading_list (rl_deleted, rl_date_updated);


CREATE TABLE /*_*/reading_list_entry (
  rle_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
  rle_rl_id INTEGER UNSIGNED NOT NULL,
  rle_user_id INTEGER UNSIGNED NOT NULL,
  rle_rlp_id INTEGER UNSIGNED NOT NULL,
  rle_title BLOB NOT NULL, rle_date_created BLOB DEFAULT '19700101000000' NOT NULL,
  rle_date_updated BLOB DEFAULT '19700101000000' NOT NULL,
  rle_deleted SMALLINT DEFAULT 0 NOT NULL
);

CREATE UNIQUE INDEX rle_list_project_title ON /*_*/reading_list_entry (rle_rl_id, rle_rlp_id, rle_title);

CREATE UNIQUE INDEX rle_list_deleted_title_id ON /*_*/reading_list_entry (
  rle_rl_id, rle_deleted, rle_title,
  rle_id
);

CREATE UNIQUE INDEX rle_list_deleted_updated_id ON /*_*/reading_list_entry (
  rle_rl_id, rle_deleted, rle_date_updated,
  rle_id
);

CREATE UNIQUE INDEX rle_user_updated_id ON /*_*/reading_list_entry (
  rle_user_id, rle_date_updated, rle_id
);

CREATE UNIQUE INDEX rle_user_project_title ON /*_*/reading_list_entry (
  rle_user_id, rle_rlp_id, rle_title,
  rle_rl_id
);

CREATE INDEX rle_deleted_updated ON /*_*/reading_list_entry (rle_deleted, rle_date_updated);


CREATE TABLE /*_*/reading_list_project (
  rlp_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
  rlp_project BLOB NOT NULL
);

CREATE UNIQUE INDEX rlp_project ON /*_*/reading_list_project (rlp_project);
